﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace cs_file_grabber
{
    class Program
    {
        /* ! \brief Gathers audio files from a directory
         *
         * Scans a directory and all its subdirectories for audio files, which ar esupported by the bass library
         * 
         * \param argv[1]: the root directory
         */
        static void Main(string[] args)
        {
            if (args.Length < 2)
            {
                Console.WriteLine("You have to specify a directory and an output-file!");
                return;
            }

            string[] types = new string[10] {".mp3",".mp2",".mp1",".ogg",".flac",".flc",".ape",".ofr",".mpa",".wma"};

            DirectoryInfo di = new DirectoryInfo(args[0]);
            FileInfo[] fileInfos = di.GetFiles("*.*",SearchOption.AllDirectories);

            using (System.IO.StreamWriter file = new System.IO.StreamWriter(args[1]))
            {
                foreach (FileInfo fi in fileInfos)
                {
                    bool isAudio = false;
                    foreach (string t in types)
                    {
                        if (fi.FullName.EndsWith(t)) isAudio = true;
                    }
                    if (isAudio)
                    {
                        file.WriteLine(fi.FullName+";");
                    }
                }
            }

            Console.WriteLine("DONE");
        }
    }
}
