var labelType, useGradients, nativeTextSupport, animate;

(function() {
  var ua = navigator.userAgent,
      iStuff = ua.match(/iPhone/i) || ua.match(/iPad/i),
      typeOfCanvas = typeof HTMLCanvasElement,
      nativeCanvasSupport = (typeOfCanvas == 'object' || typeOfCanvas == 'function'),
      textSupport = nativeCanvasSupport 
        && (typeof document.createElement('canvas').getContext('2d').fillText == 'function');
  //I'm setting this based on the fact that ExCanvas provides text support for IE
  //and that as of today iPhone/iPad current text support is lame
  labelType = (!nativeCanvasSupport || (textSupport && !iStuff))? 'Native' : 'HTML';
  nativeTextSupport = labelType == 'Native';
  useGradients = nativeCanvasSupport;
  animate = !(iStuff || !nativeCanvasSupport);
})();

/*var Log = {
  elem: false,
  write: function(text){
    if (!this.elem) 
      this.elem = document.getElementById('log');
    this.elem.innerHTML = text;
    this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
  }
};*/

var list = [];
var matrix = [];

function init(listFile, simMatrix, treshhold){
  // init data
  
	/*if (window.File && window.FileReader && window.FileList && window.Blob) {
		alert('The File APIs are not fully supported in this browser.');
		return;
	}*/
	var list = listFile;
	var matrix = simMatrix;
	
	var minLineWidth = 0.4;
	var maxLineWidth = 12.0;

	var json = [];
	
	for(i=0;i<list.length;i++) {
		
	
		var adj = [];
		var a = 0;
		for(j=i+1;j<list.length;j++) {
			if (matrix[i][j]>treshhold) {
				adj[a] = {  
					nodeTo:"node"+j,
					data: {
						"$lineWidth": minLineWidth + (maxLineWidth - minLineWidth) * (matrix[i][j] - treshhold) / (1.0- treshhold),
					}
				};
				a++;
			}
		}
		json[i] = {
			"id": "node"+i,  
			"name": ""+list[i][1],
			//"name" : "<img src=\"clem.jpg\" height='30' width='30'/>",
			"data": {  
			  "num": i,
			  "file": list[i][0],
			  "title": list[i][1],
			  "artist": list[i][2],
			  "album": list[i][3],
			  "year": list[i][4],
			  "$color": "#0000FF",
			  "$type": "square",
			  "$dim": 30
			},
			"adjacencies": adj
		};
	}

	
  // end
  // init ForceDirected
  var fd = new $jit.ForceDirected({
    //id of the visualization container
    injectInto: 'canvas',
    //Enable zooming and panning
    //by scrolling and DnD
    Navigation: {
      enable: true,
      //Enable panning events only if we're dragging the empty
      //canvas (and not a node).
      panning: 'avoid nodes',
      zooming: 10 //zoom speed. higher is more sensible
    },
    // Change node and edge styles such as
    // color and width.
    // These properties are also set per node
    // with dollar prefixed data-properties in the
    // JSON structure.
    Node: {
      overridable: true
    },
    Edge: {
      overridable: true,
      color: '#23A4FF',
      lineWidth: minLineWidth
    },
	
    //Native canvas text styling
    Label: {
      type: labelType, //Native or HTML
      size: 10,
      style: 'bold'
    },

    Tips: {
      enable: true,
      onShow: function(tip, node) {
        //count connections
        var count = 0;
        node.eachAdjacency(function() { count++; });
        //display node info in tooltip
        tip.innerHTML = "<div class=\"tip-title\">" + node.data.title + "</div>"
          + "<div class=\"tip-text\">Artist: <b>"+node.data.artist+"</b></div>"
		  + "<div class=\"tip-text\">Album: <b>"+node.data.album+"</b></div>"
		  + "<div class=\"tip-text\">Year: <b>"+node.data.year+"</b></div>";
      }
    },
    // Add node events
    Events: {
      enable: true,
      type: 'Native',
      //Change cursor style when hovering a node
      onMouseEnter: function() {
        fd.canvas.getElement().style.cursor = 'move';
      },
      onMouseLeave: function() {
        fd.canvas.getElement().style.cursor = '';
      },

      onDragMove: function(node, eventInfo, e) {
          var pos = eventInfo.getPos();
          node.pos.setc(pos.x, pos.y);
          fd.plot();
      },

      onTouchMove: function(node, eventInfo, e) {
        $jit.util.event.stop(e); //stop default touchmove event
        this.onDragMove(node, eventInfo, e);
      },

      onClick: function(node) {
        if(!node) return;
		
		$jit.id('mp3_title').innerHTML = "<b>"+node.data.title+"</b>"; 
		$jit.id('mp3_artist').innerHTML = "<b>"+node.data.artist+"</b>"; 
		$jit.id('mp3_album').innerHTML = "<b>"+node.data.album+" ("+node.data.year+")</b>"; 
		$jit.id('mp3_player').innerHTML = ""+node.data.file+"";

      }
    },
	
	NodeStyles: {  
		enable: true,  
		type: 'Native',  
		stylesHover: {  
			dim: 60,  
		},  
		duration: 600  
	},
	
    //Number of iterations for the FD algorithm
    iterations: 200,
    //Edge length
    levelDistance: 400,
    // Add text to the labels. This method is only triggered
    // on label creation and only for DOM labels (not native canvas ones).
    /*onCreateLabel: function(domElement, node){
      domElement.innerHTML = node.name;
      var style = domElement.style;
      style.fontSize = "0.8em";
      style.color = "#ddd";
    },
    // Change node styles when DOM labels are placed
    // or moved.
    onPlaceLabel: function(domElement, node){
      var style = domElement.style;
      var left = parseInt(style.left);
      var top = parseInt(style.top);
      var w = domElement.offsetWidth;
      style.left = (left - w / 2) + 'px';
      style.top = (top + 10) + 'px';
      style.display = '';
    }*/
  });
  // load JSON data.
  fd.loadJSON(json);
  // compute positions incrementally and animate.
  fd.computeIncremental({
    iter: 40,
    property: 'end',
    onStep: function(perc){
      //Log.write(perc + '% loaded...');
    },
    onComplete: function(){
      //Log.write('done');
      fd.animate({
        modes: ['linear'],
        transition: $jit.Trans.Elastic.easeOut,
        duration: 2500
      });
    }
  });
  // end
}